<div class="container d-flex flex-column justify-content-center">
  <div class="title align-self-center">Sign up</div>
  <form
    [formGroup]="signupForm"
    (submit)="onSubmit()"
    class="d-flex flex-column"
  >
    <div class="d-flex justify-content-center mb-4">
      <mat-form-field>
        <mat-label>Fist Name</mat-label>
        <input matInput placeholder="First Name" formControlName="firstName" />
        <mat-error *ngIf="signupForm.get('firstName').hasError('required')"
          >First Name is required</mat-error
        >
        <mat-error *ngIf="signupForm.get('firstName').hasError('maxlength')"
          >First Name max length is 255 characters</mat-error
        >
      </mat-form-field>
    </div>

    <div class="d-flex justify-content-center mb-4">
      <mat-form-field>
        <mat-label>Last Name</mat-label>
        <input matInput placeholder="Last Name" formControlName="lastName" />
        <mat-error *ngIf="signupForm.get('lastName').hasError('required')"
          >Last Name is required</mat-error
        >
        <mat-error *ngIf="signupForm.get('lastName').hasError('maxlength')"
          >Last Name max length is 255 characters</mat-error
        >
      </mat-form-field>
    </div>

    <div class="d-flex justify-content-center mb-4">
      <mat-form-field>
        <mat-label>Email</mat-label>
        <input matInput placeholder="Email" formControlName="email" />
        <mat-error *ngIf="signupForm.get('email').hasError('required')"
          >Email is required</mat-error
        >
        <mat-error *ngIf="signupForm.get('email').hasError('email')"
          >Invalid email</mat-error
        >
        <mat-error *ngIf="signupForm.get('email').hasError('maxlength')"
          >Max length of email is 70 characters</mat-error
        >
        <span *ngIf="isSignUpFailed && signupForm.valid" class="error"
          >This email is already taken</span
        >
      </mat-form-field>
    </div>

    <div class="d-flex justify-content-center mb-4">
      <mat-form-field>
        <mat-label>Password</mat-label>
        <input
          matInput
          type="password"
          placeholder="Password"
          formControlName="password"
        />
        <mat-error *ngIf="signupForm.get('password').hasError('required')"
          >Password is required</mat-error
        >
        <mat-error *ngIf="signupForm.get('password').hasError('minlength')"
          >Password min length is 6 characters</mat-error
        >
        <mat-error *ngIf="signupForm.get('password').hasError('maxlength')"
          >Password max length is 200 characters</mat-error
        >
      </mat-form-field>
    </div>

    <div class="d-flex justify-content-center">
      <button
        type="submit"
        mat-raised-button
      >
        Signup
      </button>
    </div>
  </form>
</div>
